//ICC-AVR application builder : 13.11.2009 14:12:42
// Target : T2313
// Crystal: 7.3728Mhz

#include <iot2313v.h>
#include <macros.h>

void port_init(void)
{
 PORTA = 0x07;
 DDRA  = 0x00; 

 PORTB = 0xE7;
 DDRB  = 0xBC; 

 PORTD = 0x1F;
 DDRD  = 0x72; 
}

//TIMER0 initialize - prescale:8
// WGM: Normal
// desired value: 104uSec
// actual value: 103,082uSec (0,9%)
void timer0_init(void)
{
 TCCR0B = 0x00; //stop timer
 TCNT0 = 0xA1; //set count
 OCR0A = 0xC0; //set count
 OCR0B = 0x5F; //set count
 TCCR0A = 0x00; //start timer
 TCCR0B = 0x02; //start timer
}

#pragma interrupt_handler timer0_compa_isr:14
void timer0_compa_isr(void)
{
 NOP();
}

#pragma interrupt_handler timer0_ovf_isr:7
void timer0_ovf_isr(void)
{
 //TIMER0 has overflowed
 TCNT0 = 0xA1; //reload counter value
}

//UART0 initialize
// desired baud rate: 9600
// actual: baud rate:9600 (0,0%)
void uart0_init(void)
{
 UCSRB = 0x00; //disable while setting baud rate
 UBRRH = 0x00; //set baud rate upper
 UBRRL = 0x2F; //set baud rate lower
 UCSRA = 0x00;
 UCSRC = 0x06;
 UCSRB = 0xD8; //enable
}

#pragma interrupt_handler uart0_rx_isr:8
void uart0_rx_isr(void)
{
 //uart has received a character in UDR
}

#pragma interrupt_handler uart0_tx_isr:10
void uart0_tx_isr(void)
{
 //character has been transmitted
}

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 timer0_init();
 uart0_init();

 MCUCR = 0x00;
 GIMSK = 0x00;
 TIMSK = 0x03;
 SEI(); //re-enable interrupts
 //all peripherals are now initialized
}

void main(void)
{
 init_devices();
 do
 {
 } while(1);
}