	.module uart.c
	.area text(rom, con, rel)
	.dbfile D:\wn\s\uart.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 9
; //ICC-AVR application builder : 13.11.2009 14:12:42
; // Target : T2313
; // Crystal: 7.3728Mhz
; 
; #include <iot2313v.h>
; #include <macros.h>
; 
; void port_init(void)
; {
	.dbline 10
;  PORTA = 0x07;
	ldi R24,7
	out 0x1b,R24
	.dbline 11
;  DDRA  = 0x00; 
	clr R2
	out 0x1a,R2
	.dbline 12
;  PORTB = 0xE7;
	ldi R24,231
	out 0x18,R24
	.dbline 13
;  DDRB  = 0xBC; 
	ldi R24,188
	out 0x17,R24
	.dbline 14
;  PORTD = 0x1F;
	ldi R24,31
	out 0x12,R24
	.dbline 15
;  DDRD  = 0x72; 
	ldi R24,114
	out 0x11,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 23
; }
; 
; //TIMER0 initialize - prescale:8
; // WGM: Normal
; // desired value: 104uSec
; // actual value: 103,082uSec (0,9%)
; void timer0_init(void)
; {
	.dbline 24
;  TCCR0B = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 25
;  TCNT0 = 0xA1; //set count
	ldi R24,161
	out 0x32,R24
	.dbline 26
;  OCR0A = 0xC0; //set count
	ldi R24,192
	out 0x36,R24
	.dbline 27
;  OCR0B = 0x5F; //set count
	ldi R24,95
	out 0x3c,R24
	.dbline 28
;  TCCR0A = 0x00; //start timer
	out 0x30,R2
	.dbline 29
;  TCCR0B = 0x02; //start timer
	ldi R24,2
	out 0x33,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 26
	rjmp _timer0_compa_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\uart.c
	.dbfunc e timer0_compa_isr _timer0_compa_isr fV
	.even
_timer0_compa_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 34
; }
; 
; #pragma interrupt_handler timer0_compa_isr:14
; void timer0_compa_isr(void)
; {
	.dbline 35
;  NOP();
	nop
	.dbline -2
L3:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\uart.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	st -y,R24
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 40
; }
; 
; #pragma interrupt_handler timer0_ovf_isr:7
; void timer0_ovf_isr(void)
; {
	.dbline 42
;  //TIMER0 has overflowed
;  TCNT0 = 0xA1; //reload counter value
	ldi R24,161
	out 0x32,R24
	.dbline -2
L4:
	ld R24,y+
	out 0x3f,R24
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 49
; }
; 
; //UART0 initialize
; // desired baud rate: 9600
; // actual: baud rate:9600 (0,0%)
; void uart0_init(void)
; {
	.dbline 50
;  UCSRB = 0x00; //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 51
;  UBRRH = 0x00; //set baud rate upper
	out 0x2,R2
	.dbline 52
;  UBRRL = 0x2F; //set baud rate lower
	ldi R24,47
	out 0x9,R24
	.dbline 53
;  UCSRA = 0x00;
	out 0xb,R2
	.dbline 54
;  UCSRC = 0x06;
	ldi R24,6
	out 0x3,R24
	.dbline 55
;  UCSRB = 0xD8; //enable
	ldi R24,216
	out 0xa,R24
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 14
	rjmp _uart0_rx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\uart.c
	.dbfunc e uart0_rx_isr _uart0_rx_isr fV
	.even
_uart0_rx_isr::
	.dbline -1
	.dbline 60
; }
; 
; #pragma interrupt_handler uart0_rx_isr:8
; void uart0_rx_isr(void)
; {
	.dbline -2
L6:
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 18
	rjmp _uart0_tx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\uart.c
	.dbfunc e uart0_tx_isr _uart0_tx_isr fV
	.even
_uart0_tx_isr::
	.dbline -1
	.dbline 66
;  //uart has received a character in UDR
; }
; 
; #pragma interrupt_handler uart0_tx_isr:10
; void uart0_tx_isr(void)
; {
	.dbline -2
L7:
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 72
;  //character has been transmitted
; }
; 
; //call this routine to initialize all peripherals
; void init_devices(void)
; {
	.dbline 74
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 75
;  port_init();
	rcall _port_init
	.dbline 76
;  timer0_init();
	rcall _timer0_init
	.dbline 77
;  uart0_init();
	rcall _uart0_init
	.dbline 79
; 
;  MCUCR = 0x00;
	clr R2
	out 0x35,R2
	.dbline 80
;  GIMSK = 0x00;
	out 0x3b,R2
	.dbline 81
;  TIMSK = 0x03;
	ldi R24,3
	out 0x39,R24
	.dbline 82
;  SEI(); //re-enable interrupts
	sei
	.dbline -2
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
	.even
_main::
	.dbline -1
	.dbline 87
;  //all peripherals are now initialized
; }
; 
; void main(void)
; {
	.dbline 88
;  init_devices();
	rcall _init_devices
L10:
	.dbline 90
;  do
;  {
	.dbline 91
L11:
	.dbline 91
	rjmp L10
X0:
	.dbline -2
L9:
	.dbline 0 ; func end
	ret
	.dbend
